<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title>Prototype encryption</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<script type="text/javascript">
		function decrypt(key,iv,value){
			var iv=pad(iv,mcrypt.get_iv_size("rijndael-128","cbc"));
			mcrypt.Crypt(null,null,iv,key,"rijndael-128","cbc");
			return mcrypt.Decrypt(hex2bin(Base64.decode(value)),iv);
		}

		function encrypt(key,iv,value){
			var iv=pad(iv,mcrypt.get_iv_size("rijndael-128","cbc"));
			mcrypt.Crypt(null,null,iv,key,"rijndael-128","cbc");
			return Base64.encode(trim(bin2hex(mcrypt.Encrypt(value,iv))));
		}

		function crypt_values(){
			var valeur=document.getElementById('value').value;

			var iv=document.getElementById("key").value.substr(16,document.getElementById("key").value.length);
			iv=pad(iv,mcrypt.get_iv_size("rijndael-128","cbc"));

			var key=document.getElementById("key").value;
			mcrypt.Crypt(null,null,iv,key,"rijndael-128","cbc");

			//crypt data
			var crypted_value=Base64.encode(trim(bin2hex(mcrypt.Encrypt(valeur,iv))));

			alert(crypted_value);
		}

		function decrypt_values(){
			var valeur=document.getElementById('value').value;

			var iv=document.getElementById("key").value.substr(16,document.getElementById("key").value.length);
			iv=pad(iv,mcrypt.get_iv_size("rijndael-128","cbc"));

			var key=document.getElementById("key").value;
			mcrypt.Crypt(null,null,iv,key,"rijndael-128","cbc");

			//decrypt from javascript encryption
			//var decrypted_value=mcrypt.Decrypt(hex2bin(trim(Base64.decode(valeur))),iv);

			//decrypt from php encryption
			var decrypted_value=mcrypt.Decrypt(trim(Base64.decode(valeur)),iv);

			alert(decrypted_value);
		}

		function pad(x,y){
			if(x.length>=y)
			return x.substr(0,y);
			for(var i=y-x.length;i;i--)
			x+=String.fromCharCode(Math.floor(Math.random()*256));
			return x;
		}

		function trim(str){
			return str.replace(/^\s+/g,'').replace(/\s+$/g,'')
		}

		var hexdigits='0123456789ABCDEF';
		var hexLookup=Array(256);
		for(var i=0;i<256;i++)
			hexLookup[i]=hexdigits.indexOf(String.fromCharCode(i));

		function bin2hex(str){
			var out='';
			for(var i=0;i<str.length;i++)
				out+=hexdigits[str.charCodeAt(i)>>4]+hexdigits[str.charCodeAt(i)&15]+' ';
			return out;
		}

		function hex2bin(str){
			var out='';
			var part=-1;
			for(var i=0;i<str.length;i++){
				var t=hexLookup[str.charCodeAt(i)]
				if(t>-1){
					if(part>-1){
						out+=String.fromCharCode(part|t);
						part=-1;
					}else
						part=t<<4;
				}
			}
			return out;
		}

		</script>
		<script type="text/javascript" src="lib/rijndael.js"></script>
		<script type="text/javascript" src="lib/mcrypt.js"></script>
		<script type="text/javascript" src="lib/encode64.js"></script>
	</head>
	<body>
		<table style="width:800px;margin-left:auto;margin-right:auto;">
			<tr>
				<td style="width:200px;text-align:right;">
					<label for="key">Clé : </label>
				</td>
				<td style="width:600px;text-align:left;">
					<input type="text" id="key" style="width:250px;" value="prAxuguwrudequ3aXutHuwa4rec6ug3p" />
				</td>
			</tr>
    		<tr>
	    		<td style="text-align:right;">
					<label for="value">Valeur : </label>
				</td>
				<td style="text-align:left;">
					<input type="text" id="value" style="width:250px;" value="" />
				</td>
			</tr>
			<tr>
				<td></td>
				<td>
					<input type="button" value="Encrypt" onclick="crypt_values();" />
					&nbsp;&nbsp;&nbsp;
					<input type="button" value="Decrypt" onclick="decrypt_values();" />
				</td>
			</tr>
    	</table>
	</body>
</html>